﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using NDde.Client; // pridane pre komunikaciu s panelom a plc cez dde a RSLINX
using System.Threading;
using System.Data.OracleClient; // pridane pre komunikaciu s oracle databazou

namespace zad1_DSR
{
    public partial class Form1 : Form
    {
        int n = 0;
        NDde.Client.DdeClient ddeRsLinx;
        const int ddeTimeout = 5000;
        bool svetlo1, svetlo2, svetlo3, svetlo4, tlac1, tlac2, tlac3, tlac4;
        bool start = false;
        
        // formatovanie stringu pre komunikaciu s oracle databazou
        OracleConnection conn;
        const string connStr = "SERVER=(DESCRIPTION=(ADDRESS=(PROTOCOL=TCP)(HOST=147.232.25.97)(PORT=1521))(CONNECT_DATA=(SERVICE_NAME=orcl))); uid=kajnak;pwd=kajnak;";

        public Form1()
        {
            InitializeComponent();
            label_db.Text = "Connection to Oracle Database status: NOT CONNECTED";
            label_plc.Text = "Connection to Panel 3 (PLC 123) status: NOT CONNECTED";
            progressBar_Pot1.Maximum = 28200;
            progressBar_Pot1.Minimum = 0;
            progressBar_Pot2.Maximum = 30500;
            progressBar_Pot2.Minimum = 0;
            //Thread oThread = new Thread(new ThreadStart(vlakno));
            //oThread.Start();
            //while (!oThread.IsAlive) ;

            # region spojenie s databazou
            // nadviazanie spojenia s databazou
            try
            {
                conn = new OracleConnection(connStr);
                conn.Open();
                label_db.Text = "Connection to Oracle Database status: SUCCESS!";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                label_db.Text = "Connection to Oracle Database status: FAILED!!!";
            }
            # endregion
        }

        private void connect_Click(object sender, EventArgs e)
        {
            # region komunikacia_s_plc
            // spustenie komunikacie s plc
            try
            {
                ddeRsLinx = new DdeClient("RsLinx", "a");
                ddeRsLinx.Connect();
                timer1.Enabled = true;
                timer2.Enabled = true;
                connect.Visible = false;
                start = true;
                label_plc.Text = "Connection to Panel 3 (PLC 123) status: SUCCESS!";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                label_plc.Text = "Connection to Panel 3 (PLC 123) status: FAILED!!!";
            }
            # endregion
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            # region potenciometre

            // pot1 a pot2
            textBox_readData1.Text = ddeRsLinx.Request("Pot1", ddeTimeout); // request nacitam
            textBox_readData2.Text = ddeRsLinx.Request("Pot2", ddeTimeout); 
            progressBar_Pot1.Value = int.Parse(ddeRsLinx.Request("Pot1", ddeTimeout)); // vlozi do progressbaru
            progressBar_Pot2.Value = int.Parse(ddeRsLinx.Request("Pot2", ddeTimeout));
            
            # endregion
        }

        # region ciselka na 7segmentovku
        
        private void nula()
        {
            
            ddeRsLinx.Poke("Local:2:O.Data.0", "0", ddeTimeout); // segment A
            ddeRsLinx.Poke("Local:2:O.Data.1", "0", ddeTimeout); // segment B
            ddeRsLinx.Poke("Local:2:O.Data.2", "0", ddeTimeout); // segment C
            ddeRsLinx.Poke("Local:2:O.Data.3", "0", ddeTimeout); // segment D
            ddeRsLinx.Poke("Local:2:O.Data.4", "0", ddeTimeout); // segment E
            ddeRsLinx.Poke("Local:2:O.Data.5", "0", ddeTimeout); // segment F
            ddeRsLinx.Poke("Local:2:O.Data.6", "0", ddeTimeout); // segment G
        }

        private void jednotka()
        {
            ddeRsLinx.Poke("Local:2:O.Data.8", "0", ddeTimeout); // adresacia prveho segmentu
            ddeRsLinx.Poke("Local:2:O.Data.9", "0", ddeTimeout); // adresacia prveho segmentu
            ddeRsLinx.Poke("Local:2:O.Data.0", "0", ddeTimeout); // segment A
            ddeRsLinx.Poke("Local:2:O.Data.1", "1", ddeTimeout); // segment B
            ddeRsLinx.Poke("Local:2:O.Data.2", "1", ddeTimeout); // segment C
            ddeRsLinx.Poke("Local:2:O.Data.3", "0", ddeTimeout); // segment D
            ddeRsLinx.Poke("Local:2:O.Data.4", "0", ddeTimeout); // segment E
            ddeRsLinx.Poke("Local:2:O.Data.5", "0", ddeTimeout); // segment F
            ddeRsLinx.Poke("Local:2:O.Data.6", "0", ddeTimeout); // segment G
        }

        private void dvojka()
        {
            ddeRsLinx.Poke("Local:2:O.Data.8", "1", ddeTimeout); // adresacia prveho segmentu
            ddeRsLinx.Poke("Local:2:O.Data.9", "0", ddeTimeout); // adresacia prveho segmentu
            ddeRsLinx.Poke("Local:2:O.Data.0", "1", ddeTimeout); // segment A
            ddeRsLinx.Poke("Local:2:O.Data.1", "1", ddeTimeout); // segment B
            ddeRsLinx.Poke("Local:2:O.Data.2", "0", ddeTimeout); // segment C
            ddeRsLinx.Poke("Local:2:O.Data.3", "1", ddeTimeout); // segment D
            ddeRsLinx.Poke("Local:2:O.Data.4", "1", ddeTimeout); // segment E
            ddeRsLinx.Poke("Local:2:O.Data.5", "0", ddeTimeout); // segment F
            ddeRsLinx.Poke("Local:2:O.Data.6", "1", ddeTimeout); // segment G
        }

        private void trojka()
        {
            ddeRsLinx.Poke("Local:2:O.Data.8", "0", ddeTimeout); // adresacia prveho segmentu
            ddeRsLinx.Poke("Local:2:O.Data.9", "1", ddeTimeout); // adresacia prveho segmentu
            ddeRsLinx.Poke("Local:2:O.Data.0", "1", ddeTimeout); // segment A
            ddeRsLinx.Poke("Local:2:O.Data.1", "1", ddeTimeout); // segment B
            ddeRsLinx.Poke("Local:2:O.Data.2", "1", ddeTimeout); // segment C
            ddeRsLinx.Poke("Local:2:O.Data.3", "1", ddeTimeout); // segment D
            ddeRsLinx.Poke("Local:2:O.Data.4", "0", ddeTimeout); // segment E
            ddeRsLinx.Poke("Local:2:O.Data.5", "0", ddeTimeout); // segment F
            ddeRsLinx.Poke("Local:2:O.Data.6", "1", ddeTimeout); // segment G
        }

        private void stvorka()
        {
            ddeRsLinx.Poke("Local:2:O.Data.8", "1", ddeTimeout); // adresacia prveho segmentu
            ddeRsLinx.Poke("Local:2:O.Data.9", "1", ddeTimeout); // adresacia prveho segmentu
            ddeRsLinx.Poke("Local:2:O.Data.0", "0", ddeTimeout); // segment A
            ddeRsLinx.Poke("Local:2:O.Data.1", "1", ddeTimeout); // segment B
            ddeRsLinx.Poke("Local:2:O.Data.2", "1", ddeTimeout); // segment C
            ddeRsLinx.Poke("Local:2:O.Data.3", "0", ddeTimeout); // segment D
            ddeRsLinx.Poke("Local:2:O.Data.4", "0", ddeTimeout); // segment E
            ddeRsLinx.Poke("Local:2:O.Data.5", "1", ddeTimeout); // segment F
            ddeRsLinx.Poke("Local:2:O.Data.6", "1", ddeTimeout); // segment G
        }
        
        #endregion

        private void timer2_Tick(object sender, EventArgs e)
        {
            # region vysvecovanie svetiel podla tlacidiel a vizualizacia na pc
            // svetlo1
            if (int.Parse(ddeRsLinx.Request("TL1", ddeTimeout)) == 1 || tl1.Checked)
            {
                ddeRsLinx.Poke("SV1", "1", ddeTimeout); // poke vyslem na zapis
                panel1.BackColor = Color.Green;
                seg1.Text = "1";
                jednotka();
            }
            else
            {
                ddeRsLinx.Poke("SV1", "0", ddeTimeout); // poke vyslem na zapis
                panel1.BackColor = Color.White;
                seg1.Text = "";
                nula();
            }

            // svetlo2
            if (int.Parse(ddeRsLinx.Request("TL2", ddeTimeout)) == 1 || tl2.Checked)
            {
                ddeRsLinx.Poke("SV2", "1", ddeTimeout); // poke vyslem na zapis
                panel2.BackColor = Color.Green;
                seg2.Text = "2";
                dvojka();
            }
            else
            {
                ddeRsLinx.Poke("SV2", "0", ddeTimeout); // poke vyslem na zapis
                panel2.BackColor = Color.White;
                seg2.Text = "";
                nula();
            }

            // svetlo3
            if (int.Parse(ddeRsLinx.Request("TL3", ddeTimeout)) == 1 || tl3.Checked)
            {
                ddeRsLinx.Poke("SV3", "1", ddeTimeout); // poke vyslem na zapis
                panel3.BackColor = Color.Green;
                seg3.Text = "3";
                trojka();
            }
            else
            {
                ddeRsLinx.Poke("SV3", "0", ddeTimeout); // poke vyslem na zapis
                panel3.BackColor = Color.White;
                seg3.Text = "";
                nula();
            }

            // svetlo4
            if (int.Parse(ddeRsLinx.Request("TL4", ddeTimeout)) == 1 || tl4.Checked)
            {
                ddeRsLinx.Poke("SV4", "1", ddeTimeout); // poke vyslem na zapis
                panel4.BackColor = Color.Green;
                seg4.Text = "4";
                stvorka();
            }
            else
            {
                ddeRsLinx.Poke("SV4", "0", ddeTimeout); // poke vyslem na zapis
                panel4.BackColor = Color.White;
                seg4.Text = "";
                nula();
            }
            # endregion
        }

        private void timer3_Tick(object sender, EventArgs e)
        {
            # region zapis do databazy
            try
            {
                if (conn.State == ConnectionState.Open)
                {
                    string time = System.DateTime.Now.ToString("dd:MM:yyyy HH:mm:ss");
                    string comStr = "INSERT INTO DSRKAJNAKBARUTIAK (POT1,POT2,TIM) VALUES (" + textBox_readData1.Text + "," + textBox_readData2.Text +",'" + time + "')";
                    OracleCommand cmd = new OracleCommand(comStr, conn);
                    int i = cmd.ExecuteNonQuery();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            # endregion
        }

        private void DBon_Click(object sender, EventArgs e)
        {
            timer3.Start();
        }

        private void DBoff_Click(object sender, EventArgs e)
        {
            timer3.Stop();
        }
  
    }
}
